/* Exit.c Exits from a program */
#ifndef __EXIT_C_
#define __EXIT_C_

#ifndef __TILOADED__
#error You must load TI.H when using EXIT.C
#endif

/* Our system call of exit.  We take the stack pointer that is retrived at
   the start of program execution and we continue poping stuff from the stack
   until we have poped everthing except the return address back to who called
   the program to begin with.
 */
_Exit(){
#asm
	; Set de = old sp
	ld	hl,startstkp
	ld	d, (hl)
	inc	hl
	ld	e, (hl)

	; Ok set hl = sp
	ld	hl, 0
	add	hl,sp

_ExitLoop:
	; Test end of stack?
	ld	a, h
	cp	d
	jr	nz,_ExitLoopStart
	ld	a, l
	cp	e
	ret	z		; Last stack item was poped now back to caller
_ExitLoopStart:
 	inc	sp		; Move past this item with out popin
	inc	sp
	dec	hl
	dec	hl
	jr	_ExitLoop
#endasm
}

#define exit(x) _Exit()

abort()
{
    puts("Abnormal Prog. Term.\n");
    exit(5);
}

#endif /* __EXIT_C_ */
